leetcocde-337. House Robber III

题目链接:https://leetcode.com/problems/house-robber-iii/
题目内容:
The thief has found himself a new place for his thievery again. There is only one entrance to this area, called the “root.” Besides the root, each house has one and only one parent house. After a tour, the smart thief realized that “all houses in this place forms a binary tree”. It will automatically contact the police if two directly-linked houses were broken into on the same night.

Determine the maximum amount of money the thief can rob tonight without alerting the police.

Example 1:

 3
/ \
2   3
\   \ 
 3   1

Maximum amount of money the thief can rob = 3 + 3 + 1 = 7.

Example 2:

 3
/ \
4   5
/ \   \ 
1   3   1

Maximum amount of money the thief can rob = 4 + 5 = 9.
题目大意:题目意思就是小偷偷钱,发现这个房间和二叉树一样,同一天晚上不能偷相连边,求出偷出最大的钱。
题目思路:利用dps深搜,递归的返回值这里需要两个,一个是表示偷窃当前节点,如果偷窃了当前节点就不能偷他下一级的节点,res[1]=表示不偷当前节点,所以当前节点的下一个节点偷不偷都无所谓,这里我们需要求出最大值即可。代码如下:

/**
 * Definition for a binary tree node.
 * public class TreeNode {
 *     int val;
 *     TreeNode left;
 *     TreeNode right;
 *     TreeNode(int x) { val = x; }
 * }
 */
public class Solution {
    public int rob(TreeNode root) {
        int[] res=dfs(root);
        return Math.max(res[0],res[1]);
    }
    public int[] dfs(TreeNode x){
        if(x==null) return new int[2];
        int[] left=dfs(x.left);
        int[] right=dfs(x.right);
        int[] res=new int[2];
        //表示这个点偷窃
        res[0]=left[1]+right[1]+x.val;
        res[1]=Math.max(left[0],left[1])+Math.max(right[0],right[1]);
        return res;
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值